#!/opt/bin/perl -w

use strict;
use File::Tail;
use Net::SSH::Perl;
use FileHandle;
use IPC::Open2;
use Sys::Syslog;

my $router="rt-1";
my $user="XXXXXXXX";
my $pass="YYYYYYYY";
my $enable="ZZZZZZZZ";
my $logfile="/var/log/router";

my @inoutdelay=(
	"Hopefully",		"en",		0,
	"rt-1>en",		"$enable",	0,
	"Password: ",		"conf t",	0,
	"Enter configuration",	"int bri0",	0,
	"int bri0",		"shut",		5,
	"shut",			"no shut",	0,
	"no shut",		"end",		0,
	"end",			"quit",		0
);

$SIG{CHLD} = 'IGNORE';

my $debug=0;

#&reset;
#exit 0;

my $lastdown="";

my $log=File::Tail->new(name=>$logfile,
  maxinterval=>5, interval=>1);

while (defined($_=$log->read)) {
    if (/^([^ ]*[ ]*[^ ]*[ ]*[^ ]*[ ]*[^ ]*[ ]*).*%ISDN-6-LAYER2DOWN:/) {
	$lastdown=$1;
    }
    if (/^([^ ]*[ ]*[^ ]*[ ]*[^ ]*[ ]*[^ ]*[ ]*).*%ISDN-6-LAYER2UP:/) {
	if ($lastdown eq $1) {
	    print "resetting BRI...";
	    &reset;
	    print "done.\n";
	};
    }
}

sub reset {
    my @cmds=@inoutdelay;

    my $ssh = Net::SSH::Perl->new($router);
    $ssh->login($user, $pass);

    my $in=shift(@cmds);
    my $out=shift(@cmds);
    my $delay=shift(@cmds);

    if (open2(*IN, *OUT, "-")) {
        while(<IN>) {
	    chomp;
	    if ($debug) {
	        print "<< $_\n";
	    }

	    if (defined $in and /$in/) {
	        if ($debug) {
		    print ">> $out\n";
	        }
	        print OUT "$out\n";
	        sleep($delay);
	        $in=shift(@cmds);
	        $out=shift(@cmds);
	        $delay=shift(@cmds);
	    }
        }
    } else {
        $ssh->shell;
        exit 0;
    }

    openlog('brireset.pl', 'cons,pid', 'local7');
    syslog('info', 'BRI on %s resetted', $router);
    closelog();
}
